open Base

type t = (string * string) list [@@deriving show]

let empty = []

let find_all t ~key =
  List.filter_map
    ~f:(fun (k, v) -> Option.some_if (String.Caseless.equal key k) v)
    t

let find t ~key =
  List.hd (find_all t ~key)

let set_all t ~key ~values =
  let new_headers = List.map ~f:(fun v -> (key, v)) values in
  let other_headers = List.filter ~f:(fun (k, _) -> not (String.Caseless.equal key k)) t in
  List.append other_headers new_headers

let set t ~key ~value =
  set_all t ~key ~values:[value]

let remove t ~key =
  set_all t ~key ~values:[]

let add t ~key ~value =
  let values = List.append (find_all t ~key) [value] in
  set_all t ~key ~values

let of_list =
  Fn.id

let to_list =
  Fn.id
