open Alcotest
open Okweb

let test_search_params =
  test_case "search params" `Quick begin fun () ->
    let body = Body.of_string "foo=one,two,three&bar=four" in
    let form = Lwt_main.run (Form.of_body body) in
    check (option (list string))
      "searching all form values"
      (Some ["one"; "two"; "three"])
      (Form.find_params form ~key:"foo");
    check (option string)
      "searching the 1st value for key 'bar'"
      (Some "four")
      (Form.find_param form ~key:"bar");
    check (option string)
      "searching the 1st value for key 'foo'"
      (Some "one")
      (Form.find_param form ~key:"foo");
  end

let cases = [
  test_search_params;
]
